#include<stdio.h>
#include<stdlib.h>

typedef struct stablo
{
	int broj;
	int tc;
	struct stablo *levi, *desni;
} stablo;

#define novi(x) x = (stablo*)malloc(sizeof(stablo))

stablo *form()
{
	stablo *p = NULL, *temp, *pom1, *pom2;
	int i, n;
	
	printf("Unesite broj elemenata stabla.\n");
	scanf("%d", &n);
	
	for(i = 0; i < n; i++)
	{
		if((novi(temp)) == NULL)
		{
			printf("Greska pri alokaciji memorije.\n");
			exit(0);
		}
		printf("Unesite broj.\n");
		scanf("%d",&temp->broj);
		temp->tc = temp->broj/100;
		temp->tc = temp->tc % 10;
		temp->levi = temp->desni = NULL;
		
		if(!p)
			p = temp;
		else
		{
			pom1 = p;
			while(pom1)
			{
				pom2 = pom1;
				if(pom1->tc > temp->tc) pom1 = pom1->levi;
					else pom1 = pom1->desni;
			}
			if(pom2->tc > temp->tc) pom2->levi = temp;
				else pom2->desni = temp;
		}
	}
	return p;
}

void stampaj(stablo *p)
{
	if(p)
    {
		stampaj(p->desni);
		printf("%d (%d) ",p->broj,p->tc);
		stampaj(p->levi);
	}
}

int broj(stablo *p, int x, int *br)
{
	if(p)
	{
		broj(p->levi,x,br);
		broj(p->desni,x,br);
		if((p->tc > 2) && (p->tc < 8) && (p->broj < x)) return ++(*br);
	}
}

main()
{
	stablo *p;
	int br = 0,x;
	
	p = form();
	stampaj(p);
	printf("\n");
	
	printf("Unesi x.\n");
	scanf("%d",&x);
	broj(p,x,&br);
	printf("Broj trazenih brojeva je: %d\n",br);
}
