#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct Lista { 
	char *naziv;
	float udaljenost;
	struct Lista *sledeci;
}element;

#define novi(x) x = (element *)malloc(sizeof(element));

void dodaj(element **p,char *ime, float km) {
	element *pom, *temp;
	novi(temp);
	if(!temp) perror("Greska pri alokaciji memorije");
	
	temp->naziv = (char*)malloc(strlen(ime)+1);
	strcpy(temp->naziv,ime);
	temp->udaljenost = km;
	
	if(!(*p)) {
		temp->sledeci = temp;
		*p = temp;
	}
	else {
		pom = *p;
		while(pom->sledeci != *p) pom = pom->sledeci;
		temp->sledeci = pom->sledeci;
		pom->sledeci = temp;
	}
}

void Ispis(element *p) {
	element *pom = p;
	do{
		printf("%s\t %f\n",pom->naziv,pom->udaljenost);
		pom = pom->sledeci;
	}while(pom!=p);
	
}

main() {
	element *p =  NULL;
	int n,i,ind = 1;
	float udaljenost;
	char s[50], ime[50], naziv[50], start[50];
	while(strcasecmp(naziv,"OKRUG")!=0)  {
		scanf("%s",naziv);
		scanf("%f",&udaljenost);
		dodaj(&p,naziv,udaljenost);
	}
	Ispis(p);
	
}
