#include <stdio.h>
#include <stdlib.h>

typedef struct node
{	
	int broj;
	int cifra;
	struct node *left;
	struct node *right;
} node;

#define new(x) x = (node*)malloc(sizeof(node))

node* form();
void add(node** p, int n, int c);
void print(node* p);
int cifra(int n);


int cifra(int n)
{
	int p = 2;
	while(p)
	{
		n /= 10;
		p--;
	}	
	return n % 10;
}

node* form()
{
	node* p = NULL;
	int b, n, c;
	scanf("%d",&b);
	while(b)
	{
		scanf("%d",&n);
		c = cifra(n);
		add(&p,n,c);
		b--;
	}
	return p;
	
}

void add(node** p, int n, int c)
{
	node *pos1, *pos2, *tmp;
	new(tmp);
	if(!tmp)
	{
		printf("Greskaa\n");
		exit(1);
	}
	tmp->broj = n;
	tmp->cifra = c;
	tmp->left = tmp->right = NULL;
	if(!(*p))
		*p = tmp;
	else
	{
		pos1 = (*p);	
		while(pos1)
		{
			pos2 = pos1;
			if(c < pos1->cifra)
				pos1 = pos1->left;
			else
				pos1 = pos1->right;
		}
		if(c < pos2->cifra)
			pos2->left = tmp;
		else
			pos2->right = tmp;
		
	}
}

void print(node* p)
{
	if(p)
	{
		print(p->right);		
		printf("%d\t%d\n",p->broj, p->cifra);
		print(p->left);
	}
}

void count(node* p, int* n, int x)
{
	if(p)
	{
		count(p->left, n, x);
		if(p->broj < x && p->cifra > 2 && p->cifra < 8)
			(*n)++;
		count(p->right, n, x);
	}
}

int main(void)
{
	node* p;
	int x, n = 0;
	p = form();
	print(p);
	printf("unesi X: \n");
	scanf("%d",&x);
	count(p,&n,x);
	printf("%d\n",n);
}

